SystemOrganization addCategory: #'A4BP-Tests-SimEngine-BPMN20'!

Object subclass: #BPSimBPMN20ExecutionTestHelper
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Tests-SimEngine-BPMN20'!

!BPSimBPMN20ExecutionTestHelper commentStamp: '<historical>' prior: 0!
A BPSimBPMN20ExecutionTestHelper is xxxxxxxxx.

Instance Variables
	count:		<Object>

count
	- xxxxx
!

!BPSimBPMN20ExecutionTestHelper methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/20/2015 16:07'!
accept: visitor
	count := count + 1.! !

!BPSimBPMN20ExecutionTestHelper methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/20/2015 16:09'!
count
	^ count ! !

!BPSimBPMN20ExecutionTestHelper methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/20/2015 16:14'!
count: a
	count := a! !

!BPSimBPMN20ExecutionTestHelper methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/20/2015 16:07'!
initialize
	super initialize.
	count := 0.! !

TestCase subclass: #BPMN20ExecutionVisitorTest
	instanceVariableNames: 'bpmnMetamodel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Tests-SimEngine-BPMN20'!

!BPMN20ExecutionVisitorTest methodsFor: 'setUp' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 14:48'!
configExecution
	|parser|
	
	parser := BPMN20Parser parseString: BPMN20SampleVerySimpleProcess bpmn02.
	bpmnMetamodel := parser definitions first process values first.! !

!BPMN20ExecutionVisitorTest methodsFor: 'testRuning' stamp: 'AlvaroJosePeraltaOcampo 4/23/2015 18:41'!
testProcessValidation

	"|execution grabber parser inputScenario bpsimdata simb|
	
	parser := BPMN20Parser parseString: BPMN20SampleVerySimpleProcess bpmn02.
	bpmnMetamodel := parser definitions first process values first.
	execution := BPSimBPMN20ExecutionVisitor new.
	grabber := BPSimBPMN20TimeVisitor new.
	bpsimdata := BPSimParser parseString: BPMN20SampleVerySimpleProcess bpmn02WithSim.
	inputScenario := bpsimdata scenarios first.
	execution addGrabber: grabber.
	execution addInputScenario: inputScenario.
	execution resourceController: BPSimResourceControllerFactory resourceController.
	simb := [ 
		(BPSimBuilder new buildScenario timer 
			processingParameters: bpmnMetamodel flowElements) currentScenario 
			].
	
	execution addOutputScenario: simb value.
	execution addFullOutputScenario:  simb value.
	execution addProcessModel: bpmnMetamodel.
	execution runExecution."
	! !

!BPMN20ExecutionVisitorTest methodsFor: 'testRuning' stamp: 'AlvaroJosePeraltaOcampo 4/23/2015 18:42'!
testTimeValidation

	"|execution grabber parser inputScenario bpsimdata simb|
	
	parser := BPMN20Parser parseString: BPMN20SampleVerySimpleProcess bpmn02.
	bpmnMetamodel := parser definitions first process values first.
	execution := BPSimBPMN20ExecutionVisitor new.
	grabber := BPSimBPMN20TimeVisitor new.
	bpsimdata := BPSimParser parseString: BPMN20SampleVerySimpleProcess bpmn02WithSim.
	inputScenario := bpsimdata scenarios first.
	
	execution addGrabber: grabber.
	execution addInputScenario: inputScenario.
	execution resourceController: BPSimResourceControllerFactory resourceController.
	simb := [ (BPSimBuilder new buildScenario timer processingParameters: bpmnMetamodel flowElements) currentScenario ].
	execution addOutputScenario: simb value.
	execution addFullOutputScenario:  simb value.
	execution addProcessModel: bpmnMetamodel.
	execution runExecution."
! !

!BPMN20ExecutionVisitorTest methodsFor: 'testRuning' stamp: 'AlvaroJosePeraltaOcampo 4/23/2015 18:42'!
testTsunamiv3TimeValidation

	"|execution grabber parser inputScenario simb task|
	
	parser := BPMN20Parser parseString: BPMN20SampleTsunamiResonponse tsunamiv3.
	bpmnMetamodel := (parser definitions first process 
	select:[:p | p aName = 'Réponse tsunami au VN']) values first.
	
	execution := BPSimBPMN20ExecutionVisitor new.
	grabber := BPSimBPMN20TimeVisitor new.
	
	simb := BPSimBuilder new.
	simb buildScenarioId: 'tsunamiInputScenario'.
	
	task := (bpmnMetamodel activities select: [ :a | a class = BPMN20TaskImpl  ]).
	simb timer processingParameters: task config:[ :t |
			| p |
			p := BPSimDurationParameter new.
			p value: 10.
			p 
		].
		
	inputScenario := simb currentScenario.
	
	execution addGrabber: grabber.
	execution addInputScenario: inputScenario.
	execution addProcessModel: bpmnMetamodel.
	execution resourceController: BPSimResourceControllerFactory resourceController.
	simb := [ (BPSimBuilder new buildScenario timer processingParameters: bpmnMetamodel flowElements) currentScenario ].
	execution addOutputScenario: simb value.
	execution addFullOutputScenario:  simb value.
	execution runExecution."
	
	"With 10 for each task activity"
	"self assert: grabber processingTime = 200."
! !

TestCase subclass: #BPSimBPMN20EngineProcessTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Tests-SimEngine-BPMN20'!

!BPSimBPMN20EngineProcessTest methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/23/2015 18:11'!
testrunTimerSimulation
	"| bpSimEngine parser bpmnMetamodel bpsimdata | 
	
	parser := BPMN20Parser parseString: BPMN20SampleVerySimpleProcess bpmn02.
	bpmnMetamodel := parser definitions first process values first.
	bpsimdata := BPSimParser parseString: BPMN20SampleVerySimpleProcess bpmn02WithSim.
	
	bpSimEngine := BPSimBPMN20EngineProcess new.
	bpSimEngine addProcessModel: bpmnMetamodel.
	bpSimEngine runSimulationUsing:  bpsimdata inputScenario."
! !

!BPSimBPMN20EngineProcessTest methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/23/2015 18:11'!
testrunTimerSimulations
	"| bpSimEngine bpmnMetamodel bpsimdata parser inprocess|
	
	bpSimEngine := BPSimBPMN20EngineProcess new.
	parser := BPMN20Parser parseString: BPMN20SampleVerySimpleProcess bpmn02.
	bpmnMetamodel := parser definitions first process values first.
	bpsimdata := BPSimParser parseString: BPMN20SampleVerySimpleProcess bpmn02WithSim.


	bpSimEngine addProcessModel: bpmnMetamodel.
	inprocess := 3.
	bpSimEngine runSimulationUsing:bpsimdata inputScenario for: inprocess.
		
	self assert: bpSimEngine simulations notNil.
	self assert: bpSimEngine simulations size = 1.
	self assert: bpSimEngine simulations first executions size = inprocess."	
! !

TestCase subclass: #BPSimBPMN20ExecutionVisitorTest
	instanceVariableNames: 'v aModel lsf1 lsf2 cb sf1 sf2 sf3 sf4 ncheck1 ncheck2 ncheck3 ncheck4 lcheck configBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Tests-SimEngine-BPMN20'!

!BPSimBPMN20ExecutionVisitorTest commentStamp: '<historical>' prior: 0!
A BPSimBPMN20ExecutionVisitorTest is a test class for testing the behavior of BPSimBPMN20ExecutionVisitor!

!BPSimBPMN20ExecutionVisitorTest methodsFor: 'tests-visitorImplFlowsGateways' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 17:59'!
setUp
	aModel := BPMN20ExclusiveGatewayImpl new.
	aModel id:'exclusiveGateway01'.
	lsf1 := Dictionary new.
	lsf2 := Dictionary new.
	ncheck1 := BPSimBPMN20ExecutionTestHelper new.
	ncheck2  := BPSimBPMN20ExecutionTestHelper new.
	ncheck3  := BPSimBPMN20ExecutionTestHelper new.
	ncheck4  := BPSimBPMN20ExecutionTestHelper new.
	lcheck := Array with:ncheck1 with:ncheck2 with:ncheck3 with:ncheck4.
	
	sf1 :=  BPMN20SequenceFlowImpl new.
	sf1 id:'sf1'.
	sf1 targetRef: ncheck1.
	lsf1 at: sf1 id put:sf1.
	lsf2 at: sf1 id put:sf1.
	
	sf2 :=  BPMN20SequenceFlowImpl new.
	sf2 id:'sf2'.
	sf2 targetRef: ncheck2.
	lsf1 at: sf2 id put:sf2.
	lsf2 at: sf2 id put:sf2.
	
	sf3 :=  BPMN20SequenceFlowImpl new.
	sf3 id:'sf3'.
	sf3 targetRef: ncheck3.
	lsf2 at: sf3 id put:sf3.
	
	sf4 :=  BPMN20SequenceFlowImpl new.
	sf4 id:'sf4'.
	sf4 targetRef: ncheck4.
	lsf2 at: sf4 id put:sf4.
	
	
	aModel outgoing: lsf1.
	
	configBlock := [ 
		|bpProcess def|
		def := BPMN20DefinitionsImpl new.
		bpProcess :=  BPMN20ProcessImpl new.
		bpProcess myRoot: def. 
		aModel parent: bpProcess.
		bpProcess addflowElement: aModel .
		v := BPSimBPMN20ExecutionVisitor new.
		v addInputScenario: BPSimScenario new.
		v addProcessModel: bpProcess.
		v
	].! !

!BPSimBPMN20ExecutionVisitorTest methodsFor: 'tests-visitorImplFlowsGateways' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 17:59'!
testVisitBPMN20ExclusiveGatewayImpl
	cb := BPSimControlBuilder new.
	v := configBlock value.
	cb addCurrentScenario: v inputScenario .
	cb probabilityParameterOn: sf1  parameterValue: (BPSimFloatingParameter new value: 0.5 ).
	cb probabilityParameterOn: sf2  parameterValue: (BPSimFloatingParameter new value: 0.5 ).
	v visitBPMN20ExclusiveGatewayImpl: aModel.
	self assert: (ncheck1 count = 1 or: ncheck2 count = 1).
	lcheck do:[ :c | c count:0].
	
	cb := BPSimControlBuilder new.
	v := configBlock value.
	cb addCurrentScenario: v inputScenario .
	cb probabilityParameterOn: sf1  parameterValue: (BPSimFloatingParameter new value: 1 ).
	cb probabilityParameterOn: sf2  parameterValue: (BPSimFloatingParameter new value: 0 ).
	v visitBPMN20ExclusiveGatewayImpl: aModel.
	self assert: (ncheck1 count = 1 and: ncheck2 count = 0).
	lcheck do:[ :c | c count:0].
	
	"using more gateways"
	aModel outgoing: lsf2.
	
	cb := BPSimControlBuilder new.
	v := configBlock value.
	cb addCurrentScenario: v inputScenario .
	cb probabilityParameterOn: sf1  parameterValue: (BPSimFloatingParameter new value: 1 ).
	cb probabilityParameterOn: sf2  parameterValue: (BPSimFloatingParameter new value: 0 ).
	cb probabilityParameterOn: sf3  parameterValue: (BPSimFloatingParameter new value: 0 ).
	cb probabilityParameterOn: sf4  parameterValue: (BPSimFloatingParameter new value: 0 ).
	v visitBPMN20ExclusiveGatewayImpl: aModel.
	self assert: (((ncheck1 count = 1 and: ncheck2 count = 0) and: ncheck3 count = 0 ) and: ncheck4 count = 0 ).
	lcheck do:[ :c | c count:0].
	
	cb := BPSimControlBuilder new.
	v := configBlock value.
	cb addCurrentScenario: v inputScenario .
	cb probabilityParameterOn: sf1  parameterValue: (BPSimFloatingParameter new value: 0 ).
	cb probabilityParameterOn: sf2  parameterValue: (BPSimFloatingParameter new value: 0 ).
	cb probabilityParameterOn: sf3  parameterValue: (BPSimFloatingParameter new value: 1 ).
	cb probabilityParameterOn: sf4  parameterValue: (BPSimFloatingParameter new value: 0 ).
	v visitBPMN20ExclusiveGatewayImpl: aModel.
	self assert: (((ncheck1 count = 0 and: ncheck2 count = 0) and: ncheck3 count = 1 ) and: ncheck4 count = 0 ).
	lcheck do:[ :c | c count:0].

	cb := BPSimControlBuilder new.
	v := configBlock value.
	cb addCurrentScenario: v inputScenario .
	cb probabilityParameterOn: sf1  parameterValue: (BPSimFloatingParameter new value: 0 ).
	cb probabilityParameterOn: sf2  parameterValue: (BPSimFloatingParameter new value: 0 ).
	cb probabilityParameterOn: sf3  parameterValue: (BPSimFloatingParameter new value: 0 ).
	cb probabilityParameterOn: sf4  parameterValue: (BPSimFloatingParameter new value: 1 ).
	v visitBPMN20ExclusiveGatewayImpl: aModel.
	self assert: (((ncheck1 count = 0 and: ncheck2 count = 0) and: ncheck3 count = 0 ) and: ncheck4 count = 1 ).
	lcheck do:[ :c | c count:0].
	
	cb := BPSimControlBuilder new.
	v := configBlock value.
	cb addCurrentScenario: v inputScenario .
	cb probabilityParameterOn: sf1  parameterValue: (BPSimFloatingParameter new value: 0.25 ).
	cb probabilityParameterOn: sf2  parameterValue: (BPSimFloatingParameter new value: 0.25 ).
	cb probabilityParameterOn: sf3  parameterValue: (BPSimFloatingParameter new value: 0.25 ).
	cb probabilityParameterOn: sf4  parameterValue: (BPSimFloatingParameter new value: 0.25 ).
	v visitBPMN20ExclusiveGatewayImpl: aModel.
	self assert: (((ncheck1 count = 1 or: ncheck2 count = 1) or: ncheck3 count = 1 ) or: ncheck4 count = 1 ).
	lcheck do:[ :c | c count:0].! !

!BPSimBPMN20ExecutionVisitorTest methodsFor: 'tests-visitorImplFlowsGateways' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 17:59'!
testVisitBPMN20ExclusiveGatewayImpl1_0
	cb := BPSimControlBuilder new.
	v := configBlock value.
	cb addCurrentScenario: v inputScenario .
	cb probabilityParameterOn: sf1  parameterValue: (BPSimFloatingParameter new value: 1 ).
	cb probabilityParameterOn: sf2  parameterValue: (BPSimFloatingParameter new value: 0 ).
	v visitBPMN20ExclusiveGatewayImpl: aModel.
	self assert: (ncheck1 count = 1 and: ncheck2 count = 0).
	lcheck do:[ :c | c count:0].
	! !

TestCase subclass: #BPSimBPMN20TimeVisitorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Tests-SimEngine-BPMN20'!

!BPSimBPMN20TimeVisitorTest commentStamp: '<historical>' prior: 0!
A BPSimBPMN20TimeVisitorTest is a test class for testing the behavior of BPSimBPMN20TimeVisitor!

!BPSimBPMN20TimeVisitorTest methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/23/2015 09:17'!
testHistoricalTime
	|parser inputScenario simb bpmnMetamodel  bpSimEngine simulation el|
	
	parser := BPMN20Parser parseString: BPMN20SampleTsunamiResonponse tsunamiv3.
	bpmnMetamodel := (parser definitions first process select:[:p | p aName = 'Réponse tsunami au VN']) values first.
	
	bpSimEngine := BPSimBPMN20EngineProcess new.
	bpSimEngine addProcessModel: bpmnMetamodel.
	simb := BPSimBuilder buildScenarioId: 'tsunamiInputScenario01'.
	simb processModel: bpmnMetamodel.

	simb timer processingTime: ( simb duration value: 10 ) inElementName: 'T8'' : Evacuate people'.
	simb timer processingTime: ( simb duration value: 10 ) inElementName: 'T6 : Inform by portable speakers'.
	simb timer processingTime: ( simb duration value: 10 ) inElementName: 'T5 : Notify functional units to start'.
	simb timer processingTime: ( simb duration value: 10 ) inElementName: 'T4 : Fire the flares'.
	simb timer processingTime: ( simb duration value: 10 ) inElementName:'T3 : Receive tsunami start '.
	simb timer processingTime: ( simb duration value: 10 ) inElementName:'T16 : Receive tsunami end'.
	simb timer processingTime: ( simb duration value: 10 ) inElementName:'T9'' : Transfer injuries to safe places'.
	simb timer processingTime: ( simb duration value: 10 ) inElementName:'T11 : Protect the property'.
	simb timer processingTime: ( simb duration value: 10 ) inElementName:'T20 : Close tsunami reponse'.
	simb timer processingTime: ( simb duration value: 10 ) inElementName:'T10 : Inform, guide the fisherman'.
	simb timer processingTime: ( simb duration value: 10 ) inElementName:'T7 : Broadcast over the media'.
	simb timer processingTime: ( simb duration value: 10 ) inElementName:'T13 : Call ambulance '.
	simb timer processingTime: ( simb duration value: 10 ) inElementName:'T18 : Identify damages'.
	simb timer processingTime: ( simb duration value: 10 ) inElementName:'T19 : Search distress fishermen'.
	simb timer processingTime: ( simb duration value: 10 ) inElementName:'T9 : Transfer injuries to safe places'.
	simb timer processingTime: ( simb duration value: 10 ) inElementName:'T17 : Notify functional units to end'.
	simb timer processingTime: ( simb duration value: 10 ) inElementName:'T12 : Perform the first aid'.
	simb timer processingTime: ( simb duration value: 10 ) inElementName:'T18'' : Identify damages'.
	simb timer processingTime: ( simb duration value: 10 ) inElementName:'T8 : Evacuate people'.
	simb timer processingTime: ( simb duration value: 10 ) inElementName:'T19'' : Search distress fishermen'.

	inputScenario := simb currentScenario.
	bpSimEngine runSimulationSimpleThreadUsing: inputScenario.
	
	"Start test process"
	
	simulation := bpSimEngine simulations first.
	self assert: simulation notNil.
	el :=  simulation out getParameterByName: 'T3 : Receive tsunami start '.
	self assert: el notNil.
	self assert: el historicalTime vv = 10.	
	el :=  simulation out getParameterByName:  'T5 : Notify functional units to start'.
	self assert: el notNil.
	self assert: el historicalTime vv = 20.	
	el :=  simulation out getParameterByName:  'T4 : Fire the flares'.
	self assert: el notNil.
	self assert: el historicalTime vv = 20.	
	el :=  simulation out getParameterByName: 'T6 : Inform by portable speakers'.
	self assert: el notNil.
	self assert: el historicalTime vv = 30.
	

	^ bpSimEngine
! !
